//core.h

//from "d:\tc\project\geometry\point.h"
////////////////////////////////////////////////////////////////////////
class POINT
{
 public:
 int x,y;
 void COPY_TO(POINT *point);
};
////////////////////////////////////////////////////////////////////////

//from "d:\tc\project\geometry\rect.h"
///////////////////////////////////////////////////////////////////////
class RECT
{
 public:
 int left,top,right,bottom;
 RECT(int l,int t,int sx,int sy);
 void setpoints(int l,int t,int r,int b);
 virtual void move(int deltax,int deltay);
 RECT copy(RECT *rect);
 int pointinrect(POINT *p);
 RECT(){;}
};
////////////////////////////////////////////////////////////////////////

//from "d:\tc\project\core\xstring.h"
///////////////////////////////////////////////////////////////////////////
class String {
public:
	char *char_ptr;   // pointer to string contents
	int length;       // length of string in characters

	// four different constructors
	String(char *text);            //using char *
	String(String *text);          // constructor using existing string
	String(int size = 80);         // creates default empty string
	String(String& Other_String);  // for assignment from another
				  // object of this class
	~String() {delete char_ptr;};  // inline destructor
	int Get_len (void);
	String operator+ (String& Arg); //append string with string
	String operator+ (char *cp);    //append string with char *
	void INSERT_CHAR(int atposition,char character);
	void DELETE_CHAR(int atposition);
	//void charwidth
	void Show (void);
};
///////////////////////////////////////////////////////////////////////////


//from "d:\tc\project\core\objects.h"
//////////////////////////////////////////////////////////////////////////
class MSG{
 public:
 HCONSOLE hConsole;
 UINT message;
 WPARAM wParam;
 LPARAM lParam;
 DWORD time;
 POINT pt;
 MSG();
 MSG( HCONSOLE mhConsole,
		UINT mmessage,
		WPARAM mwParam,
		LPARAM mlParam);
void copy(MSG *m);
void display(int x,int y);
~MSG();
};
////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////
class FLAG{
public:
unsigned int flag;
FLAG(){};
int getbit(unsigned int bit);
void setbit(unsigned int bit);
void resetbit(unsigned int bit);
};
////////////////////////////////////////////////////////////////////////


//from "d:\tc\project\nexus\nexus.h"
class NEXUS{
public:
 //data members
 NEXUS *next;
 NEXUS *previous;
 //member functions
 NEXUS();
 NEXUS *GET_NEXT();
 NEXUS *operator ++();
 NEXUS *operator --();
 //NEXUS *operator +(int n);
 //NEXUS *operator -(int n);
 int IS_PRIMUS()
	  {
		if((previous==NULL)&&(next!=NULL))
		return(1);else return(0);
	  };
 int IS_MAXIMUS()
	  {
		if((next==NULL)&&(previous!=NULL))
		return(1);else return(0);
	  };
 int IS_INTERNEXUS()
	  {
		if((previous!=NULL)&&(next!=NULL))
		return(1);else return(0);
	  };
 int IS_UNUSNEXUS()
	  {
		if((previous==NULL)&&(next==NULL))
		return(1);else return(0);
	  };
~NEXUS();
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////
class ROTI : public NEXUS
{
public:
 //data members
 NEXUS *PRIMUS;
 NEXUS *MAXIMUS;
 NEXUS *PROXIMUS;
 NEXUS *BUFF;
 //member functions
 ROTI();
 void PUT_PRIMUS(NEXUS *p);
 void PUT_MAXIMUS(NEXUS *p);
 void PUT_BEFORE_PROXIMUS(NEXUS *p);
 void PUT_AFTER_PROXIMUS(NEXUS *p);
 void PUT_BEFORE_NEXUS(NEXUS *p,NEXUS *q);
 void PUT_AFTER_NEXUS(NEXUS *p,NEXUS *q);
 void XFER(NEXUS *n,ROTI *r);
 void DELETE_NEXUS(NEXUS *p);
 void FOR_EACH(pMF pFunc);
 void EXTRACT_NEXUS(NEXUS *p);
~ROTI();
};
/////////////////////////////////////////////////////////////////////

//from "d:\tc\project\nexus\impulse.h"
//classes////////////////////////////////////////////////////////////////////
class impulse: public NEXUS
{
 public://access modifier
//data members///////////////////////////////////////////////////////////////
 pMF RESPOND;                   //*function to call if message = CONDITION
 unsigned int *VAR;             //unsigned int pointer to a variable to check
 unsigned int CONDITION;        //value to compare condition with
//member functions///////////////////////////////////////////////////////////
 impulse();                             //default constructor sets all to NULL
 impulse(impulse *i);                   //constructer using impulse *
 impulse(unsigned int Message,          //consructor to make a response
	 pMF pFunc);
 impulse(unsigned int *Var,             //consructor to make a reflex
	 unsigned int Condition,
	 pMF pFunc);
 void makeresponse(unsigned int Message,//function to make a response
			pMF pFunc);
 void makereflex(unsigned int *Var,     //function to make a reflex
		 unsigned int Condition,
		 pMF pFunc);
 void respond(NEXUS *pN);               //function to call when responding

 virtual ~impulse();                   //destructor
};
/////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////
class Reactor : public ROTI
{
public:
 //data members
 //member functions
 Reactor();
 //void DefineResponse(impulse *im);
  impulse *DefineReflex(unsigned int *Var,
			 unsigned int Condition,
			 pMF pFunc);
  impulse *DefineResponse(unsigned int Message,
			  pMF pFunc);
  virtual void Reflex(NEXUS *pN);
  virtual void Respond(MSG *Msg,NEXUS *pN);
  ~Reactor();
};
////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////
class Coordinator
{
public:
Reactor *ACTIVE;
Reactor *INACTIVE;
Coordinator();
impulse *MakeReflex(unsigned int *Var,
			 unsigned int Condition,
			 pMF pFunc);
impulse *MakeResponse(unsigned int Message,
			  pMF pFunc);
void Activate(impulse *i);
void Deactivate(impulse *i);
virtual void Reflex(NEXUS *pN);
virtual void Respond(MSG *Msg,NEXUS *pN);
~Coordinator();
};
////////////////////////////////////////////////////////////////////

//from "d:\tc\project\core\msgqueue.h"
class MSG_NODE : public NEXUS
{
public:
 //data members
 MSG *pMSG;
 //member functions
 MSG_NODE();
 MSG_NODE(MSG *i);
 ~MSG_NODE();
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////
class MSG_QUEUE : public ROTI
{
public:
 //data members
 //MSG_NODE *first;
 //MSG_NODE *last;
 //MSG_NODE *head,*tail;
 //MSG *Mbuf;
 //member functions
 MSG_QUEUE();
 //void DefineResponse(MSG_NODE *im);
 void ADD_MESSAGE(MSG *message);
 void DELETE_MESSAGE(MSG_NODE *p);
 MSG *GET_PRIMUS_MESSAGE();
 ~MSG_QUEUE();
};
/////////////////////////////////////////////////////////////////////


//from "d:\tc\project\core\componen.h"
////////////////////////////////////////////////////////////////////////////
class Component:  public  NEXUS
{
public:
unsigned int ID;
char *NAME;
MSG_QUEUE *MSG_BIN;
Coordinator *reflexor,*responder;
Component(char *NAME, unsigned int id);//?
Component *operator ++(){return ((Component *)next);};
Component *operator --(){return ((Component *)previous);};
PostMessage();
void Respond(MSG *Msg);
void Reflex();
~Component();
};
////////////////////////////////////////////////////////////////////////////


//from "d:\tc\project\core\console.h"
////////////////////////////////////////////////////////////////////////////
class Console : public ROTI
{
public:
unsigned int ID;
char *NAME;
unsigned int active;

Coordinator *responder,*reflexor;
impulse *iStart,*iStop;
MSG_QUEUE *MSGQ;
Console(char *n,unsigned int id);
Console(char *n);
void initialize(char *n,unsigned int id);
virtual void start();
virtual void stop();
virtual void AddComponent(char *text,
		  unsigned int id);
void AddComponent_primus(unsigned int id);
void add_before_Component(unsigned int id,unsigned int o);
void add_after_Component(unsigned int id,unsigned int o);
void Respond(MSG *Msg);
void Reflex();
~Console();
};
////////////////////////////////////////////////////////////////////////////

//from "d:\tc\project\core\module.h"
////////////////////////////////////////////////////////////////////////////
class Module : public ROTI
{
public:
unsigned int ID;
char *NAME;
unsigned int active;

Coordinator *responder,*reflexor;
impulse *iStart,*iStop;
MSG_QUEUE *MSGQ;
Module(char *n,unsigned int id);
Module(char *n);
void initialize(char *n,unsigned int id);
virtual void start();
virtual void stop();
virtual void AddConsole(char *text,
		  unsigned int id);
void AddConsole_primus(unsigned int id);
void add_before_Console(unsigned int id,unsigned int o);
void add_after_Console(unsigned int id,unsigned int o);
void Respond(MSG *Msg);
void Reflex();
void INITIALIZE();
void SHUTDOWN();
~Module();
};
////////////////////////////////////////////////////////////////////////////

//from "d:\tc\project\core\modulatr.h"
////////////////////////////////////////////////////////////////////////////
class Modulator : public ROTI
{
public:
unsigned int ID;
char *NAME;
unsigned int active;

Coordinator *responder,*reflexor;
impulse *iStart,*iStop;
MSG_QUEUE *MSGQ;
Modulator(char *n,unsigned int id);
Modulator(char *n);
void initialize(char *n,unsigned int id);
virtual void start();
virtual void stop();
virtual void AddModule(char *text,
		  unsigned int id);
void AddModule_primus(unsigned int id);
void add_before_Module(unsigned int id,unsigned int o);
void add_after_Module(unsigned int id,unsigned int o);
void Respond(MSG *Msg);
void Reflex();
void INITIALIZE();
void SHUTDOWN();
~Modulator();
};
////////////////////////////////////////////////////////////////////////////
