//////////////////////////////////////////////////////////////////
class Console_NODE : public NEXUS
{
public:
 //data members
 Console *pConsole;
 //member functions
 Console_NODE();
 Console_NODE(Console *i);
 ~Console_NODE();
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////
class Console_QUEUE : public ROTI
{
public:
 //data members
 //member functions
 Console_QUEUE();
 //void DefineResponse(Console_NODE *im);
 void Reflex();
 void Respond(MSG *Msg);
 void ADD_Console(Console *console);
 void DELETE_Console(Console_NODE *p);
 Console *GET_PRIMUS_Console();
 ~Console_QUEUE();
};
/////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
class MODULE
{
Console_QUEUE *ConsoleQ;
MODULE();
void INITIALIZE();
void SHUTDOWN();
void Reflex();
void Respond(MSG *Msg);
void ADD_Console(Console *console);
~MODULE();
};
///////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
Console_NODE::Console_NODE():NEXUS()
{
next=NULL;
previous=NULL;
pConsole=NULL;
};
///////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////
Console_NODE::Console_NODE(Console *i):NEXUS()
{
 pConsole=new Console(i->NAME,i->ID);
 next     =       NULL;
 previous =       NULL;
};
///////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
Console_NODE::~Console_NODE()
{
if(pConsole!=NULL)delete pConsole;
};
///////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
Console_QUEUE::Console_QUEUE():ROTI()
{
}
///////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void Console_QUEUE::ADD_Console(Console *console)
{
 Console_NODE* newConsole_NODE = new Console_NODE(console);

PUT_MAXIMUS((NEXUS *)newConsole_NODE);
}
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void Console_QUEUE::Respond(MSG *Msg)
{
Console_NODE *x;

for(x = (Console_NODE *)PRIMUS;
    x != NULL;
    x =(Console_NODE *)++(*x)) x->pConsole->Respond(Msg);
};
////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void Console_QUEUE::Reflex()
{
Console_NODE *x;
for(x=(Console_NODE *)PRIMUS;
    x!=NULL;
    x=(Console_NODE *)++(*x))x->pConsole->reflexor->Reflex(x);
};
///////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////
Console *Console_QUEUE::GET_PRIMUS_Console()
{
Console_NODE *i;
if(PRIMUS!=NULL)
{
i=(Console_NODE *)PRIMUS;
return(i->pConsole);
};
return(NULL);
};
//////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////
void Console_QUEUE::DELETE_Console(Console_NODE *p)
{
EXTRACT_NEXUS((NEXUS *)p);
if (p!=NULL)delete p;
}
//////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////
Console_QUEUE::~Console_QUEUE()
{
 if(PRIMUS!=NULL)
 {
  Console_NODE* NEXT;
  Console_NODE* current = (Console_NODE *)PRIMUS;
  for(;;)
     {
      NEXT=(Console_NODE *)current->next;
      if(current!=NULL)DELETE_Console(current);
      if(NEXT == NULL)break;
      current=NEXT;
     }
 }
}
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
MODULE::MODULE()
{
ConsoleQ=new Console_QUEUE();
};

void MODULE::INITIALIZE()
{
/* _psp is the starting address of the
   program in memory.  The top of the stack
   is the end of the program.  Using _SS and
   _SP together we can get the end of the
   stack.  You may want to allow a bit of
   saftey space to insure that enough room
   is being allocated ie:
   (_SS + ((_SP + safety space)/16) - _psp)
*/

keep(0, (_SS + (_SP/16) - _psp));
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void MODULE::SHUTDOWN()
{
//ConsoleQ may need to be deleted here ?
exit(0);
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void MODULE::Respond(MSG *Msg)
{
//responder->Respond(Msg,this);
ConsoleQ->Respond(Msg);
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void MODULE::Reflex()
{
//reflexor->Reflex();
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void MODULE::ADD_Console(Console *console)
{
ConsoleQ->ADD_Console(console);
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
MODULE::~MODULE()
{
if(ConsoleQ!=NULL)delete ConsoleQ;
};
///////////////////////////////////////////////////////////////////
