#include <string.h>
char *dtoa(double num,char *str,int ndig=16);
//                      <<CLASSES>>
//#define NULL 0L
///////////////////////////////////////////////////////////////////////////
class String {
public:
   char *char_ptr;   // pointer to string contents
   int length;       // length of string in characters

   // four different constructors
   String(char *text);            //using char *
   String(String *text);          // constructor using existing string
   String(int size = 80);         // creates default empty string
   String(String& Other_String);  // for assignment from another
				  // object of this class
   ~String() {delete char_ptr;};  // inline destructor
   int Get_len (void);
   String operator+ (String& Arg); //append string with string
   String operator+ (char *cp);    //append string with char *
   void INSERT_CHAR(int atposition,char character);
   void DELETE_CHAR(int atposition);
   //void charwidth
   void Show (void);
};
///////////////////////////////////////////////////////////////////////////

//                 <<VARIABLES>>
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

//                  <<FUNCTION DECLARATIONS>>
///////////////////////////////////////////////////////////////////////////
void charinstrat(unsigned char c,unsigned char *str,int p);
///////////////////////////////////////////////////////////////////////////


//                   <<CLASS MEMBER FUNCTION DEFINITIONS>>
///////////////////////////////////////////////////////////////////////////
String::String (char *text)
{
   length = strlen(text);   // get length of text
   char_ptr = new char[length + 1];
   strcpy(char_ptr, text);
};

String::String (String *text)
{
   length =text->length;   // get length of text
   char_ptr = new char[length + 1];
   strcpy(char_ptr, text->char_ptr);
};

String::String (int size)
{
   length = size;
   char_ptr = new char[length+1];
   *char_ptr = '\0';
};

String::String (String& Other_String)
{
   length = Other_String.length;         // length of other string
   char_ptr = new char [length + 1];     // allocate the memory
   strcpy (char_ptr, Other_String.char_ptr);   // copy the text
};

String String::operator+ (String& Arg)
{
   String Temp( length + Arg.length );
   strcpy(Temp.char_ptr, char_ptr);
   strcat(Temp.char_ptr, Arg.char_ptr);
   return Temp;
}
String String::operator+ (char *cp)
{
   String Temp( length + strlen(cp));
   strcpy(Temp.char_ptr, char_ptr);
   strcat(Temp.char_ptr, cp);
   return Temp;
}
int String::Get_len(void)
{
   length=strlen(char_ptr);
   return (length);
};
///////////////////////////////////////////////////////////////////
void String::INSERT_CHAR(int atposition,char character)
{
 length=strlen(char_ptr);
 for(int position=length;position>=atposition;position--)
    {
     char_ptr[position+1]=char_ptr[position];
    };
 char_ptr[atposition]=character;
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void String::DELETE_CHAR(int atposition)
{
 length=strlen(char_ptr);
 for(int position=atposition;position<=length;position++)
    {
     char_ptr[position]=char_ptr[position+1];
    };
};
////////////////////////////////////////////////////////////////////

///
//////////////////////////////////////////////////////////////////////

//                    <<FUNCTION DEFINITIONS>>
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
void charinstrat(unsigned char c,unsigned char *str,int p)
{
 int top;
 unsigned char check;
 top=sizeof(str);
 if(*(str+top)=='\0')top--;
 for(int x=top;x>p;x--)
    {
      *(str+x)=*(str+(x-1));
    };
 *(str+p)=c;
};
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////
char *dtoa(double num,char *str,int ndig)
{
//variables for string conversion
 char *intstr,*dp_and_dec,*decistr;
 char *signstr="-";
 char *dpstr=".";
 char *zstr="0000000000000000";
 int deci,sign;

 deci=0;
 sign=0;
 //intstr=new char [32];
 //str=(char *)malloc(32);

 dp_and_dec=new char [32];
 decistr=new char [17];



 //intstr[0]='\0';
 str[0]='\0';

 intstr=fcvt(num,ndig,&deci,&sign);

 itoa(deci,decistr,10);

 if ((deci<strlen(intstr))&(deci>=0))
    {
     strcpy(dp_and_dec,dpstr);
     strcat(dp_and_dec,(intstr+deci));
     strncpy((intstr+deci),dp_and_dec,strlen(dp_and_dec)+1);
    };

 if (deci<0)
   {
    strcpy(dp_and_dec,dpstr);
    strcat(dp_and_dec,zstr);
    strncpy(dp_and_dec+abs(deci)+1,intstr,strlen(intstr)+1);
    strcpy(intstr,dp_and_dec);
   };

 if(sign>0)
   {
    strcpy(str,signstr);
    strcat(str,intstr);
   };

  if(sign==0)
    {
     strcpy(str,intstr);
    };
  //delete intstr;
  delete dp_and_dec;
  delete decistr;
return(str);
};
////////////////////////////////////////////////////////////////////////
