/************************************************/
/* 						*/
/*     BGI common defines/utility functions	*/
/*		Copyright (c) 1994		*/
/*	    Jordan Hargraphix Software		*/
/*						*/
/************************************************/
#ifndef __SVGAUTIL_H__
#define __SVGAUTIL_H__

typedef unsigned char DacPalette16[16][3];
typedef unsigned char DacPalette256[256][3];

#define	XNOR_PUT	5
#define NOR_PUT		6
#define NAND_PUT	7
#define TRANS_COPY_PUT	8	/* Doesn't work with 16-color drivers */

#pragma pack(1)
typedef struct __bpp24 {
  unsigned char bVal;
  unsigned char gVal;
  unsigned char rVal;
} __bpp24;

typedef struct __bpp16 {
  unsigned int bVal : 5;
  unsigned int gVal : 6;
  unsigned int rVal : 5;
} __bpp16;

typedef struct __bpp15 {
  unsigned int bVal : 5;
  unsigned int gVal : 5;
  unsigned int rVal : 5;
} __bpp15;

typedef union {
  struct __bpp24 c24;
  struct __bpp16 c16;
  struct __bpp15 c15;
  unsigned long  cval;
} __rColor;
#pragma pack()


extern "C" {


/* Define enhanced color setting functions */
long RGB(char,char,char);
long __RealDrawColor(long);
long RealFillColor(long);
long RealColor(long);

/* Define palette functions */
void getvgapalette16(DacPalette16 *);
void getvgapalette256(DacPalette256 *);


};


#endif /* __SVGAUTIL_H__ */
/************************************************/
/* 						*/
/*       SuperVGA 256 BGI driver defines	*/
/*		Copyright (c) 1991		*/
/*	    Jordan Hargraphix Software		*/
/*						*/
/************************************************/

#ifndef __SVGA256_H__
#define __SVGA256_H__

extern int far _Cdecl Svga256_fdriver[];

/* These are the currently supported modes */
#define	SVGA320x200x256		0	/* 320x200x256 Standard VGA */
#define	SVGA640x400x256		1	/* 640x400x256 Svga/VESA */
#define	SVGA640x480x256		2	/* 640x480x256 Svga/VESA */
#define	SVGA800x600x256		3	/* 800x600x256 Svga/VESA */
#define	SVGA1024x768x256	4	/* 1024x768x256 Svga/VESA */
#define	SVGA640x350x256		5	/* 640x350x256 Svga/VESA */
#define	SVGA1280x1024x256	6	/* 1280x1024x256 Svga/VESA */

#endif /* __SVGA256_H__ */


int huge DetectVGA256();
void initgrafix();



int huge DetectVGA256()
{
  int Vid;
 /*
    0 = 320x200x256
    1 = 640x400x256
    2 = 640x480x256
    3 = 800x600x256
    4 = 1024x768x256
    5 = 640x480x256
    6 = 1280x1024x256
 */
 Vid=3;
  return Vid;
};

int huge DetectVGA16()
{
  int Vid;
 /*/   0) 320x200x16\n");
    1) 640x200x16\n");
    2) 640x350x16\n");
    3) 640x480x256\n");
    4) 800x600x16\n");
    5) 1024x768x16\n");
    6) 1280x1024x16\n");
 /*/
 Vid = 5;
    return Vid;
}

void initgrafix()
{
  int  Gd = DETECT, Gm;
  int  Drv;
  char GrErr;

installuserdriver("Svga256",DetectVGA256);
/*  If driver is linked with file, remove comments */
/*          registerfarbgidriver(Svga256_fdriver); */

//use this for SVGA16
// installuserdriver("Svga16",DetectVGA16);
/*  If driver is linked with file, remove comments */
/*          registerfarbgidriver(Svga16_fdriver);  */



  initgraph(&Gd,&Gm,"d:\\tc\\bgi");

  /* Test if mode was initialized successfully */
  GrErr = graphresult();
  if (GrErr != grOk) {
	 exit(1);
  }


  settextstyle( SMALL_FONT,0,4);
  setusercharsize(11,9,11,9);
  //MOUSE.install();
  //INSTALL_MOUSE_HANDLER();
  //MOUSE.show();
  /* Draw an 'X' on the screen */
  //settextboxcolors(8,7,0);
  //settextstyle(SMALL_FONT,0,4);
  //setusercharsize(1,1,1,1); //1,2,4,11
  //settextstyle(EUROPEAN_FONT,0,4);
  //setusercharsize(5,10,5,10);
  //settextstyle(DEFAULT_FONT,0,4);
  //settextstyle( TRIPLEX_FONT,0,4);
  //settextstyle( SMALL_FONT,0,4);
  //setusercharsize(11,9,11,9);
  //settextstyle( SANS_SERIF_FONT,0,4);
  //setusercharsize(6,10,6,10);
  //settextstyle( GOTHIC_FONT,0,4);
  //settextstyle( SCRIPT_FONT,0,4);
  //setusercharsize(5,10,5,10);
  //settextstyle( SIMPLEX_FONT,0,4);
  //setusercharsize(5,10,5,10);
  //settextstyle( TRIPLEX_SCR_FONT,0,4);
  //setusercharsize(4,10,4,10);
  //settextstyle( COMPLEX_FONT,0,4);
  //setusercharsize(4,10,4,10);
  //settextstyle( BOLD_FONT,0,4);
  //setusercharsize(2,10,2,10);
  //setusercharsize(3,10,3,10);
  setcolor(15);
}