//modified: to work with allegro graphics library for DJGPP, June 1 2002, Billy Stiltner
#define KEY_PRESS 2000
//special keys that have AsciiCodes
#define BackSpace       8
#define Tab             9
#define Enter           13
#define Escape          27

//define ScanCode constants  for
//characters that have 0 ascii value
#define F1              59
#define F2              60
#define F3              61
#define F4              62
#define F5              63
#define F6              64
#define F7              65
#define F8              66
#define F9              67
#define F10             68
//#define F11             87
//#define F12             88

#define PrtScn_SysReq   84
#define ScrollLock      70
//#define PauseBreak

#define Insert          82
#define Home            71
#define PageUp          73
#define Delete          83
#define End             79
#define PageDown        81

#define UpArrow         72
#define LeftArrow       75
#define DownArrow       80
#define RightArrow      77
#define Keypad5         76
#define Plus            78
#define Minus           74


#define rightshift 1
#define leftshift 2
#define ctrl 4
#define alt 8
#define scrolll 16
#define numl 32
#define capsl 64
#define insertl 128

int nullkey;
int myKey;
int keycheck(void);

class  KEY_DEVICE:public Module{
public:
unsigned char AsciiChar,ScanCode,KeyPressed,Flags,LeftShift,
			RightShift,Ctrl,Alt,ScrollL,NumL,CapsL,InsertL;
impulse *iCHECKPRESS;
 KEY_DEVICE();
void getkey(void);
void checkpress(void);
};

 KEY_DEVICE *kb;//make a public instance for other modules to use

KEY_DEVICE::KEY_DEVICE(void):Module("KEYBOARD",2000)
{
AsciiChar=0;
ScanCode=0;
KeyPressed=0;
Flags=0;
LeftShift=0;
RightShift=0;
Ctrl=0;
Alt=0;
ScrollL=0;
NumL=0;
CapsL=0;
InsertL=0;
install_keyboard();
iCHECKPRESS=reflexor->MAKE_REFLEX(KEY_DEVICE,
				  &active,
				  1,
				  checkpress);
reflexor->Activate(iCHECKPRESS);
};

void KEY_DEVICE::checkpress(void)
{
 KeyPressed=0;
 if(keypressed()!=0)
	{
	 KeyPressed=1;
	 getkey();
	 POST_MESSAGE(NULL,
		 KEY_PRESS,
		 ScanCode,
		 AsciiChar,
		 NULL_POINT);
	};
};

void KEY_DEVICE::getkey(void)
{
int whatkey;
whatkey=readkey();


  AsciiChar=whatkey & 0xff;
  ScanCode=whatkey >> 8;
  Flags=key_shifts;
  if((rightshift & Flags) == rightshift) RightShift = 1; else RightShift = 0;
  if((leftshift  & Flags) ==  leftshift) LeftShift  = 1; else LeftShift  = 0;
  if((ctrl       & Flags) ==       ctrl) Ctrl       = 1; else Ctrl       = 0;
  if((alt        & Flags) ==        alt) Alt        = 1; else Alt        = 0;
  if((scrolll    & Flags) ==    scrolll) ScrollL = 1; else ScrollL = 0;
  if((numl       & Flags) ==       numl) NumL    = 1; else NumL    = 0;
  if((capsl      & Flags) ==      capsl) CapsL   = 1; else CapsL   = 0;
  if((insertl    & Flags) ==    insertl) InsertL = 1; else InsertL = 0;

};
//////////////////////////////////////////////////////////////////////
int keycheck(void)
{
 if (kb->KeyPressed==1)
	 {
		 if (kb->AsciiChar==0)
	 {
	  nullkey=1;
	  return(kb->ScanCode);
	 };//end of if ascii char=0

	  return(kb->AsciiChar);
	};
  return(0);
};
/////////////////////////////////////////////////////////////////////


