//#include<objects.h>
//LBN = LEFT BUTTON
//RBN = RIGHT BUTTON
/////////////////////////////////////////////////////////////////////////////
#define MOUSE_ACTION 1000
#define LBN_PRESS 1100
#define RBN_PRESS 1101
#define MBN_PRESS 1102
#define LBN_RELEASE 1103
#define RBN_RELEASE 1104
#define MBN_RELEASE 1105
#define MOUSE_MOVE 1106
#define NO_RELEASE 1107

/////////////////////////////////////////////////////////////////////////////
unsigned mh_off,mh_seg;
//const null=0;
static unsigned int MouseAction;
static unsigned int myMouseFlags;
int mymouseaction;
////////////////////////////////////////////////////////////////////////////
static void MOUSE_HANDLER(int flags);


////////////////////////////////////////////////////////////////////////////
class POINTING_DEVICE: public Module
{
public:
impulse *iACTION;
POINT pdPOINT;
POINT pdOLD_POINT;
unsigned int ACTION;
 int  On,//if the mouse is ENABLED this will be 1
		//if the mouse is DISABLED this will be 0
		//On is changed by calling ON() or OFF()

	     VISIBLE,//if the mouse is shown this will be 1.
			  //VISIBLE is changed by calling show() or hide()

	     //the following variables are changed each time a mouse
	     //hardware interrupt occurs and mousehandler() is installed
	     LBN_PRESSED,//this will be one if a left button press occurs
	     LBN_RELEASED,//this will be one if a left button release occurs
	     RBN_PRESSED,//this will be one if a right button press occurs
	     RBN_RELEASED,//this will be one if a right button release occurs

		  //the following variables are changed each time
	     //a mouse hardware interrupt occurs and mousehandler() is
	     //installed or move() is called
		  MOVE_X,//this holds how far the mouse moved on the x axis
	     MOVE_Y,//this holds how far the mouse moved on the y axis
	     L_BUTTON,//this holds the state of the left button
	     R_BUTTON,//this holds the state of the right button
	     OLD_L_BUTTON,//this holds the old state of the left button
	     OLD_R_BUTTON;//this holds the old state of the right button

 //int arrow[32];
 //int inverse[32];
 POINTING_DEVICE();
 void install();
 void hide();
 void show();
 void read();
// void setarrow();
// void setinverse();
// void setcursor(int xhot,int yhot,char *arptr);
//void setcursor(CURSOR *CP);
 void OFF();
 void ON();
 void mousehandler(void);
 void INSTALL_HANDLER(void);
~POINTING_DEVICE();
};
/////////////////////////////////////////////////////////////////////////

POINTING_DEVICE *MOUSE;//make a public instance for other modules to use



///////////////////////////////////////////////////////////////////////
POINTING_DEVICE::POINTING_DEVICE():Module("MOUSE",1000)
{
MouseAction=0;
ACTION=0;
 On=0;
 VISIBLE=0;
 LBN_PRESSED=0;
 LBN_RELEASED=0;
 RBN_PRESSED =0;
 RBN_RELEASED=0;
 MOVE_X      =0;
 MOVE_Y      =0;
 L_BUTTON    =0;
 R_BUTTON    =0;
 OLD_L_BUTTON=0;
 OLD_R_BUTTON=0;
 pdPOINT.x=0;
 pdPOINT.y=0;
 iACTION=reflexor->MAKE_REFLEX(POINTING_DEVICE,&MouseAction,1,mousehandler);
// reflexor->Deactivate(iACTION);
};

POINTING_DEVICE::~POINTING_DEVICE()
{
};

////////////////////////////////////////////////////////////////////////
void POINTING_DEVICE::install()//                     
{

install_mouse();
install_timer();
show();
On=1;
VISIBLE=1;
LOCK_VARIABLE(MouseAction);
LOCK_VARIABLE(myMouseFlags);
//LOCK_FUNCTION((void *)MOUSE_HANDLER);
INSTALL_HANDLER();
//ACTION=1;
}; //                     
/////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void POINTING_DEVICE::hide()//                     
{

 if((VISIBLE==1)&(On==1)){
  show_mouse(NULL);
   VISIBLE=0;
  };
};//                     
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void POINTING_DEVICE::show()//                     
{

 if((VISIBLE==0)&&(On==1)){
  show_mouse(screen);
    VISIBLE=1;
};
};                   //                     
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void POINTING_DEVICE::OFF()
{
 if(On==1)
   {
     hide();
     	  On=0;
    };
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void POINTING_DEVICE::ON()
{
 if(On==0)
   {
    
   On=1;
	show();
   };
};
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void POINTING_DEVICE::read() //                   
 {
 int xx,yy,l,r;
// OLD_X = pdPOINT.x;	        //save previous x
// OLD_Y = pdPOINT.y;	        //save previous y
 pdPOINT.COPY_TO(&pdOLD_POINT);//save previous point
 OLD_L_BUTTON = L_BUTTON; //save previous L_BUTTON
 OLD_R_BUTTON = R_BUTTON; //save previous R_BUTTON

//if(mouse_needs_poll())poll_mouse();

poll_mouse();

pdPOINT.x=mouse_x;
pdPOINT.y=mouse_y;
get_mouse_mickeys(&MOVE_X,&MOVE_Y);

if(mouse_b & 1)L_BUTTON=1; else L_BUTTON=0;
if(!(mouse_b & 2))R_BUTTON=0; else R_BUTTON=1;


};
//**********************************************************************
/*
void POINTING_DEVICE::setcursor(CURSOR *CP)
{

int *arptr;
int xhot,yhot;
unsigned mSeg,Off;
arptr=CP->ipCURSOR;
xhot=CP->xHOT;
yhot=CP->yHOT;
hide();
mSeg=FP_SEG(arptr);
Off=FP_OFF(arptr);
asm{
	 push es;
	 mov ax,9;
	 mov bx,xhot;    //x-hot
	 mov cx,yhot;   //y-hot
	 mov dx,mSeg;
	 mov es,dx;
	 mov dx,Off;
	 int 33h;
	 pop es;
	 };
show();

};
*/


	//////////////////////////////////////////////////////////////////////////
void POINTING_DEVICE::mousehandler(void)
{
MouseAction=0;
pdPOINT.COPY_TO(&pdOLD_POINT);//save previous point
OLD_L_BUTTON = L_BUTTON; //save previous L_BUTTON
OLD_R_BUTTON = R_BUTTON; //save previous R_BUTTON

//if(mouse_needs_poll())poll_mouse();
poll_mouse();

LBN_PRESSED=0;
LBN_RELEASED=0;
RBN_PRESSED=0;
RBN_RELEASED=0;
MOVE_X=0;
MOVE_Y=0;
if(myMouseFlags & MOUSE_FLAG_LEFT_DOWN)LBN_PRESSED=1;
if(myMouseFlags & MOUSE_FLAG_LEFT_UP)LBN_RELEASED=1;
if(myMouseFlags & MOUSE_FLAG_RIGHT_DOWN)RBN_PRESSED=1;
if(myMouseFlags & MOUSE_FLAG_RIGHT_UP)RBN_RELEASED=1;

pdPOINT.x=mouse_x;
pdPOINT.y=mouse_y;

get_mouse_mickeys(&MOVE_X,&MOVE_Y);

    if(RBN_RELEASED>0)
      {
       R_BUTTON=0;
       POST_MESSAGE(NULL,
       RBN_RELEASE,
       MOVE_X,
       MOVE_Y,
       pdPOINT);
		};
      if(RBN_PRESSED>0)
	{
	 R_BUTTON=1;
	 POST_MESSAGE(NULL,
	 RBN_PRESS,
	 MOVE_X,
	 MOVE_Y,
	 pdPOINT);
	};
		if(LBN_RELEASED>0)
	{
	 L_BUTTON=0;
	 POST_MESSAGE(NULL,
	 LBN_RELEASE,
	 MOVE_X,
	 MOVE_Y,
	 pdPOINT);
	};
      if(LBN_PRESSED>0)
	 {
	 //cout<<"LBN_PRESSED";
	  L_BUTTON=1;
	  POST_MESSAGE(NULL,
	  LBN_PRESS,
	  MOVE_X,
	  MOVE_Y,
	  pdPOINT);
	 };
		if((MOVE_X != 0) || (MOVE_Y != 0))
			 POST_MESSAGE(NULL,
				 MOUSE_MOVE,
				 MOVE_X,
				 MOVE_Y,
				 pdPOINT);
};
//////////////////////////////////////////////////////////////////////////

void POINTING_DEVICE::INSTALL_HANDLER(void)
{
/*  unsigned seg, off;


  seg = FP_SEG(MOUSE_HANDLER);
  off = FP_OFF(MOUSE_HANDLER);
  _ES = seg;
  _DX = off;
  _CX = 31;//mask
  _AX = 0x14;
  geninterrupt(0x33);
*/
mouse_callback=&MOUSE_HANDLER;

};

void MOUSE_HANDLER(int flags)	// default event handler
{
MouseAction=1;
myMouseFlags=flags;
  //EventExit();				// required for interrupt function

};
END_OF_FUNCTION(MOUSE_HANDLER);

//

