Point buf;

class Hedron{
public:
 double deltax;
 double deltay;
 double deltaz;
 double sinxp;
 double sinyp;
 double sinzp;
 double cosxp;
 double cosyp;
 double coszp;
 double sinxn;
 double sinyn;
 double sinzn;
 double cosxn;
 double cosyn;
 double coszn;
 char *filename;
 int points;
 int polys;
 Point point[64];
 Point center;
 Poly poly[32];
 Hedron::Hedron(void);
 void make_handle(char *fn);

 void init(void);
 void convert(void);
 void sort(void);
 void kbhandler(int k);
 void setpoints(int p){points=p;};
 void setpolys(int p){polys=p;};
 void setpoint(int i,double x,double y,double z){point[i].x3D=x,
						 point[i].y3D=y,
						 point[i].z3D=z;};
 void setpoint(int i,Point pnt){point[i]=pnt;};
 void setcenter(Point pnt){center=pnt;};
 void setcenter(double x,double y,double z){center.x3D=x,
					    center.y3D=y,
					    center.z3D=z;};
 void setdelta(double x=10,double y=10,double z=10){deltax=x,
						    deltay=y,
						    deltaz=z;};

 void setdeltas();
 void setcolors(int c);
 void setfilleds(int f);
 void draw(void);
 void hide(void);
 void left();
 void right();
 void up();
 void writepi();
 void down();
 void forward();
 void backward();
 void rotate_zp();
 void rotate_yp();
 void rotate_xp();
 void rotate_zn();
 void rotate_yn();
 void rotate_xn();

 void moveto(Point dest);
};
///////////////////////////////////////////////////////////////};
void load(void *obj,char *filename,int size);
void save(void *obj,char *filename,int size);
///////////////////////////////////////////////////////////////
Hedron::Hedron(void)
{
setdeltas();
filename=new char[32];
strcpy(filename,"c:\\hedron.pi");
};
///////////////////////////////////////////////////////////////

void Hedron::setcolors(int c)
{
int index;
for(index=0;index<32;index++)
    {
    poly[index].setcolor(c);
    };
};

void Hedron::setfilleds(int f)
{
int index;
for(index=0;index<32;index++)
    {
    poly[index].filled=f;
    };
};
/////////////////////////////////////////////////////////////////////////
void load(void *obj,char *filename,int size)
{
int handle;
handle = open(filename,O_RDONLY);
    read(handle,(char *)obj,size);
   close(handle);
//ifstream infile;
//infile.open(filename);
//infile.seekg(0);
//infile.read((char *)obj,size);
};
/////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////
void save(void *obj,char *filename,int size)
{
int handle;
handle = open(filename,O_WRONLY);
write(handle,(char *)obj,size);
close(handle);
};
/////////////////////////////////////////////////////////////////////////
void Hedron::writepi()
{
int handle;
char numpoints[30];
char xx[30],yy[30],zz[30];
handle = open(filename,O_WRONLY);

for(int x=0;x<polys;x++)
   {
     write(handle,"object{",strlen("object{"));         //object{
     itoa(poly[x].points,numpoints,10);
     write(handle,"\npolygon",strlen("\npolygon"));       //polygon
     write(handle," ",strlen(" "));
     write(handle,numpoints,strlen(numpoints));//numpoints
      for(int p=0;p<poly[x].points;p++)
	  {

	    dtoa(point[poly[x].order[p]].x3D,xx,3);
	    dtoa(point[poly[x].order[p]].y3D*(-1),yy,3);
	    dtoa(point[poly[x].order[p]].z3D,zz,3);
	    write(handle,",\n<",strlen(",\n<")); //,<
	    write(handle,
		  xx,
		  strlen(xx));  //x
		  write(handle,",",strlen(","));                //,
	    write(handle,
		  yy,
		  strlen(yy));  //y
		  write(handle,",",strlen(","));                //,
	    write(handle,
		  zz,
		  strlen(zz)); //z
		  write(handle,">",strlen(">"));

	  };
	  write(handle,"\n}\n",strlen("\n}\n"));
    };

    close(handle);
};
////////////////////////////////////////////////////////////////////////};
void Hedron::init(void)
{
setpoints(0);
setpolys(0);
setdelta();
};
//////////////////////////////////////////////////////////////////};

void Hedron::setdeltas()
{
 deltax=10;
 deltay=10;
 deltaz=10;
 sinxp=sin(M_PI/16);;
 sinyp=sinxp;
 sinzp=sinxp;
 cosxp=cos(M_PI/16);
 cosyp=cosxp;
 coszp=cosxp;
 sinxn=sin(-(M_PI/16));
 sinyn=sinxn;
 sinzn=sinxn;
 cosxn=cos(-(M_PI/16));
 cosyn=cosxn;
 coszn=cosxn;
};
////////////////////////////////////////////////////////////////////////};
void Hedron::convert(void)
{
int index,index2;

 for(index=0; index < points; index++)
    {
      point[index].x2D=(int)320+(point[index].x3D/(point[index].z3D+d)*d);
      point[index].y2D=(int)240+(point[index].y3D/(point[index].z3D+d)*d);
    };
 center.x2D=(int)320+(center.x3D/(center.z3D+d)*d);
 center.y2D=(int)240+(center.y3D/(center.z3D+d)*d);

 for(index=0; index < polys; index++)
    {//loop until through polyhedron's polys
     for(index2=0; index2 < poly[index].points; index2++)
	{//loop until through poly's points
	 //poly's point is equal to polyhedron's n'th point
	 //n being equal to poly's order
	 poly[index].point[index2].x = point[poly[index].order[index2]].x2D;
	 poly[index].point[index2].y = point[poly[index].order[index2]].y2D;
	};
    };

};//};
/////////////////////////////////////////////////////////////////////////};

/////////////////////////////////////////////////////////////////////////};
void Hedron::draw(void)
{
int index;//,index1;
  for(index=0;index<polys;index++)
   {
   setwritemode(XOR_PUT);
   setcolor(poly[index].color);
   drawpoly(poly[index].points,(int *)poly[index].point);
   if(poly[index].filled==1)
      {
      setfillstyle(SOLID_FILL,poly[index].color);
      fillpoly(poly[index].points,(int *)poly[index].point);
      };
   };
  setwritemode(COPY_PUT);
};//};
////////////////////////////////////////////////////////////////////////};

/////////////////////////////////////////////////////////////////////////};
void Hedron::hide(void)
{
int index;//,index1;
  for(index=0;index<polys;index++)
   {
   setwritemode(XOR_PUT);
   setcolor(poly[index].color);
   drawpoly(poly[index].points,(int *)poly[index].point);
   if(poly[index].filled==1)
      {
       setfillstyle(SOLID_FILL,poly[index].color);
       fillpoly(poly[index].points,(int *)poly[index].point);
      };
   };
  setwritemode(COPY_PUT);
};//};
////////////////////////////////////////////////////////////////////////};

////////////////////////////////////////////////////////////////////////};
void Hedron::left()
{
int index;

  for (index=0; index<points;index++)
    {
     point[index].x3D = point[index].x3D - deltax;
   };
  center.x3D = center.x3D - deltax;
};//};
/////////////////////////////////////////////////////////////////////////};

/////////////////////////////////////////////////////////////////////////};
void Hedron::right()
{
 int index;

  for (index=0; index<points;index++)
    {
     point[index].x3D = point[index].x3D + deltax;
   };
  center.x3D = center.x3D + deltax;
};//};
/////////////////////////////////////////////////////////////////////////};

/////////////////////////////////////////////////////////////////////////};
void Hedron::up()
{
int index;

  for (index=0; index<points;index++)
    {
     point[index].y3D = point[index].y3D - deltay;
   };
  center.y3D = center.y3D - deltay;
};//};
////////////////////////////////////////////////////////////////////////};

////////////////////////////////////////////////////////////////////////};
void Hedron::down()
{
int index;

  for (index=0; index<points;index++)
    {
     point[index].y3D = point[index].y3D + deltay;
   };
  center.y3D = center.y3D + deltay;
};//};
///////////////////////////////////////////////////////////////////////};

///////////////////////////////////////////////////////////////////////};
void Hedron::forward()
{
int index;

  for (index=0; index<points;index++)
    {
     point[index].z3D = point[index].z3D + deltaz;
   };
  center.z3D = center.z3D + deltaz;
};//};
//////////////////////////////////////////////////////////////////////};

//////////////////////////////////////////////////////////////////////};
void Hedron::backward()
{
int index;

  for (index=0; index<points;index++)
    {
     point[index].z3D = point[index].z3D - deltaz;
   };
  center.z3D = center.z3D - deltaz;
};//};
//////////////////////////////////////////////////////////////////////};

//////////////////////////////////////////////////////////////////////};
void Hedron::rotate_zp()
{
int index;
double newx3D,newy3D;

   for(index=0;index<points;index++)
      {
       newx3D=center.x3D + ((point[index].x3D - center.x3D) * coszp
			  - (point[index].y3D - center.y3D) * sinzp);
       newy3D=center.y3D + ((point[index].x3D - center.x3D) * sinzp
			  + (point[index].y3D - center.y3D) * coszp);

       point[index].x3D=newx3D;
	point[index].y3D=newy3D;
       };
};//};
//////////////////////////////////////////////////////////////////////};

//////////////////////////////////////////////////////////////////////};
void Hedron::rotate_yp()
{
int index;
double newx3D,newz3D;

   for(index=0;index<points;index++)
      {
       newx3D=center.x3D + ((point[index].x3D - center.x3D) * cosyp
			  - (point[index].z3D - center.z3D) * sinyp);
       newz3D=center.z3D + ((point[index].x3D - center.x3D) * sinyp
			  + (point[index].z3D - center.z3D) * cosyp);

       point[index].x3D=newx3D;
	point[index].z3D=newz3D;
       };
};//};
///////////////////////////////////////////////////////////////////////};

///////////////////////////////////////////////////////////////////////};
void Hedron::rotate_xp()
{
int index;
double newz3D,newy3D;

   for(index=0;index<points;index++)
      {
       newz3D=center.z3D + ((point[index].z3D - center.z3D) * cosxp
			  - (point[index].y3D - center.y3D) * sinxp);
       newy3D=center.y3D + ((point[index].z3D - center.z3D) * sinxp
			  + (point[index].y3D - center.y3D) * cosxp);

       point[index].z3D=newz3D;
	point[index].y3D=newy3D;
       };
};//
//////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////};
void Hedron::rotate_zn()
{
int index;
double newx3D,newy3D;

   for(index=0;index<points;index++)
      {
       newx3D=center.x3D + ((point[index].x3D - center.x3D) * coszn
			  - (point[index].y3D - center.y3D) * sinzn);
       newy3D=center.y3D + ((point[index].x3D - center.x3D) * sinzn
			  + (point[index].y3D - center.y3D) * coszn);

       point[index].x3D=newx3D;
	point[index].y3D=newy3D;
       };
};//};
//////////////////////////////////////////////////////////////////////};

//////////////////////////////////////////////////////////////////////};
void Hedron::rotate_yn()
{
int index;
double newx3D,newz3D;

   for(index=0;index<points;index++)
      {
       newx3D=center.x3D + ((point[index].x3D - center.x3D) * cosyn
			  - (point[index].z3D - center.z3D) * sinyn);
       newz3D=center.z3D + ((point[index].x3D - center.x3D) * sinyn
			  + (point[index].z3D - center.z3D) * cosyn);

       point[index].x3D=newx3D;
	point[index].z3D=newz3D;
       };
};//};
///////////////////////////////////////////////////////////////////////};

///////////////////////////////////////////////////////////////////////};
void Hedron::rotate_xn()
{
int index;
double newz3D,newy3D;

   for(index=0;index<points;index++)
      {
       newz3D=center.z3D + ((point[index].z3D - center.z3D) * cosxn
			  - (point[index].y3D - center.y3D) * sinxn);
       newy3D=center.y3D + ((point[index].z3D - center.z3D) * sinxn
			  + (point[index].y3D - center.y3D) * cosxn);

       point[index].z3D=newz3D;
	point[index].y3D=newy3D;
       };
};//
//////////////////////////////////////////////////////////////

void Hedron::moveto(Point dest)
{
int index;
Point delta;
delta=dest-center;
for(index=0;index<points;index++)
   {
    point[index]=point[index]+delta;
   };
   center=center+delta;
};


void Hedron::kbhandler(int k)
{



   //hide();
   if (m.r_button==1)
      {
       buf.x3D=m.mox*deltax;
       buf.z3D=-m.moy*deltaz;
       buf.y3D=0;
       moveto(buf+center);
       }
   else{
	buf.x3D=m.mox*deltax;
	buf.y3D=m.moy*deltay;
       buf.z3D=0;
       moveto(buf+center);
       };


if(k==F1)
  {
     forward();
    };
if(k==F2)
  {
     backward();
    };

if((k==LeftArrow)|(joy_stick.left==1))
  {
     left();
    };

if((k==RightArrow)|(joy_stick.right==1))
  {
     right();
    };

if((k==UpArrow)|(joy_stick.up==1))
  {
     up();
     };

if((k==DownArrow)|(joy_stick.down==1))
  {
     down();
     };

if(k==Insert)
   {
      rotate_xp();
     };
if(k==Delete)
   {
      rotate_xn();
     };
if(k==Home)
   {
      rotate_yp();
     };
if(k==End)
   {
      rotate_zn();
     };
if(k==PageUp)
   {
      rotate_yn();
     };
if(k==PageDown)
   {
      rotate_zp();
     };
   //convert();
   // draw();
};

