#include<string.h>
///////////////////////////////////////////////////////////////////
class pushbutton{
public:
int left,top,right,bottom,sizex,sizey;
int message;
char *cpFace;
int facesize;
int size;
char filename[32];
bitmap bmp;
pushbutton(int lft,int top,int sx,int sy,char fname[32],int msg);
void draw(int x,int y);
void draw(void);
void down();
void up();
void check(int *msg);
void make(int sx,int sy,char filename[32]);
void edit(void);
void save(void);
void move(int deltax,int deltay);
~pushbutton(void);
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
class pbtoolbar{
public:
char *background;
int left,top,right,bottom,bsizex,bsizey,buttons,currentbutton,bkgsize,active;
pushbutton *tbutton[16];
pbtoolbar(int l,int t,int btnsizex,int btnsizey,int btns);
void insertbutton(char fname[32],int msg,int position);
void draw(void);
int check(int msg);
int getbutton(void);
void drag();
void move(int deltax,int deltay);
~pbtoolbar(void);
};
///////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////
pushbutton::pushbutton(int l,int t,int sx,int sy,char fname[32],int msg)
{
strcpy(filename,fname);
message=msg;
left=l;top=t;
right=l+sx+3;
bottom=t+sy+3;
sizex=sx;
sizey=sy;
size=imagesize(left+2,top+2,right-2,bottom-2);
//cpFace=new char[size];
cpFace=(char far *)bmp.load(fname);
};
///////////////////////////////////////////////////////////////////
void pushbutton::move(int deltax,int deltay)
{
   left=left+deltax;
   right=right+deltax;
   top=top+deltay;
   bottom=bottom+deltay;
};



///////////////////////////////////////////////////////////////////
void pushbutton::draw(int x,int y)
{
putimage(x,y,cpFace,0);
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void pushbutton::draw()
{
putimage(left,top,cpFace,0);
};
///////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////
void pushbutton::up()
{
//bright lines
//bar(left+1,top+1,right+1,bottom+1,0);
setcolor(0);
line(left+1,top,right-1,top);
line(left,top+1,left,bottom-1);
line(right,top+1,right,bottom-1);
line(left+1,bottom,right-1,bottom);
setcolor(15);
line(left+1,top+1,right-1,top+1);
line(left+1,top+1,left+1,bottom-1);

setcolor(8);
//horizontal high shade
//line(left+2,bottom-1,right,bottom-1);
line(left+2,bottom-1,right-1,bottom-1);
//vertical inside shade
//line(right-1,top+2,right-1,bottom);
line(right-1,top+2,right-1,bottom-1);

setcolor(7);
putpixel(right-1,top+1,7);

putpixel(left+1,bottom-1,7);

//button face
putimage(left+2,top+2,cpFace,0);
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void pushbutton::down()
{

  setcolor(0);
  line(left+1,top,right-1,top);
  line(left,top+1,left,bottom-1);
  line(right,top+1,right,bottom-1);
  line(left+1,bottom,right-1,bottom);

  //grey fill
  setfillstyle(1,8);
  bar(left+1,top+1,right-1,bottom-1);
  setfillstyle(1,7);
  bar(left+2,top+2,right-1,bottom-1);
  putimage(left+3,top+3,cpFace,0);
};
///////////////////////////////////////////////////////////////////

void pushbutton::check(int *msg)
{
if (m.l_button==1)
    {
    if((m.mx>left+2)&&(m.mx<right-2)&&(m.my>top+2)&&(m.my<bottom-2))
      {
       m.hide();
       down();
       m.show();
       while(m.l_button==1)
	     {
	     };
       if((m.mx>left+2)&&(m.mx<right-2)&&(m.my>top+2)&&(m.my<bottom-2))
	  {
	   *msg=message;
	  };
       m.hide();
       up();
      m.show();
      };
   };
};
///////////////////////////////////////////////////////////////////
void pushbutton::make(int sx,int sy,char fname[32])
{
size=imagesize(0,0,sx,sy);
cpFace=new char[size];
strcpy(filename,fname);
setfillstyle(1,7);
bar(100,100,100+sx-1,100+sy-1);
m.read();

while (m.r_button==0)
      {
       m.read();
       setcolor(15);
       box(0,0,319,199);
       box(0,0,319,199);

       if(m.l_button==1)
	 {
	 m.hide();
	 putpixel(m.mx,m.my,0);
	 m.show();
	 };
       };
m.hide();
getimage(100,100,100+sx-1,100+sy-1,cpFace);
m.show();
bmp.save(filename,cpFace,1);
cpFace=(char far *)bmp.load(filename);
putimage(100,100,cpFace,0);
if(cpFace!=NULL)delete cpFace;
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void pushbutton::edit(void)
{
draw(100,100);
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void pushbutton::save(void)
{
char *bface;
bface=new char[size];
getimage(100,100,115,115,bface);
bmp.save(filename,bface,1);
cpFace=(char far *)bmp.load(filename);
};
///////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////
pushbutton::~pushbutton(void)
{
if(cpFace!=NULL)delete cpFace;
};
///////////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////////////
pbtoolbar::pbtoolbar(int l,int t,int btnsizex,int btnsizey,int btns)
{
active=0;
left=l;
top=t;
buttons=btns;
bsizex=btnsizex;
bsizey=btnsizey;
right=l+4+(buttons*(bsizex+5));
bottom=t+8+bsizey;
currentbutton=0;
bkgsize=imagesize(left,top,right,bottom);
background=new char[bkgsize];
getimage(left,top,right,bottom,background);
};
///////////////////////////////////////////////////////////////////






///////////////////////////////////////////////////////////////////
void pbtoolbar::insertbutton(char fname[32],int msg,int position)
{
tbutton[position]=new pushbutton(left+3+(position*(bsizex+5)),
							top+3,
						       bsizex,
						       bsizey,
							fname,
							 msg);
};


void pbtoolbar::draw(void)
{
int index;
setfillstyle(1,7);
bar(left+1,top+1,right-1,bottom-1);
setcolor(0);
line(left+1,top,right-1,top);
line(left,top+1,left,bottom-1);
line(right,top+1,right,bottom-1);
line(left+1,bottom,right-1,bottom);



for (index=0; index < buttons; index++)
   {
    tbutton[index]->up();
   };
   if (active==1)
    {
     // box(currentbutton*17+2+left,top+2,currentbutton*17+19+left,top+19,15);
    };
};
///////////////////////////////////////////////////////////////////
 ///////////////////////////////////////////////////////////////////
int pbtoolbar::check(int msg)
{
int index,pbd;
//check for mouse press in toolbar
if(((m.l_button==1)&&(m.my>top+3)&&(m.my<bottom-1)&&(m.mx<right-2)&&(m.mx>left+2)))
{

for (index = 0; index<buttons; index++)
  {
   if((m.mx<tbutton[index]->right)&&(m.mx>tbutton[index]->left))
      {
	m.hide();
	tbutton[index]->down();
	m.show();
	pbd=index;
	index=buttons;
	while (m.l_button!=0)
   {
     m.read();
   };


   if((m.mx<tbutton[pbd]->right)&&(m.mx>tbutton[pbd]->left))
      {
       if(m.my>top)
	 {
	  currentbutton=pbd;
	    m.hide();
	   // pCurrenttoolbar=this;
	   // pCurrenttoolbar->active=1;
	   // pCurrenttoolbar->draw();
	   tbutton[pbd]->up();
	    m.show();

	  return(tbutton[pbd]->message);

	 };
      };
       m.hide();
    tbutton[pbd]->up();
    m.show();
};


      };
   };
   //m.hide();
   //pCurrenttoolbar->active=0;
  // pCurrenttoolbar->draw();
  // m.show();
   //wait for release


  return(msg);
};
///////////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////
int pbtoolbar::getbutton(void)
{
return(currentbutton);
};




void pbtoolbar::drag()
 {
       int xx,yy,index;
       int oldx,oldy,dx,sx,sy;
       m.read();
       xx=left;yy=m.my;
       dx=(m.mx)-left;
       sx=right-left;
       sy=bottom-top;
    if (m.l_button==1)
      {
       m.hide();

       m.show();
	 while (m.l_button == 1)
	      {

		m.read();
		xx=(m.mx)-dx;
		yy=m.my;
		oldx=(m.old_x)-dx;
		oldy=m.old_y;
		m.hide();
		setwritemode(XOR_PUT);
		setcolor(15);
		box(xx,yy,xx+sx,yy+sy);//
		 box(0,0,639,479);
		 box(0,0,639,479);
		 box(0,0,639,479);
		 box(0,0,639,479);
		box(xx,yy,xx+sx,yy+sy);//
		m.show();

	      };
	  m.hide();
	    setwritemode(COPY_PUT);
	    dx=xx-left;
     for (index=0; index < buttons; index++)
	{
	 tbutton[index]->left=tbutton[index]->left+dx;
	 tbutton[index]->right=tbutton[index]->right+dx;
	 tbutton[index]->top=yy+3;
	 tbutton[index]->bottom=yy+tbutton[index]->sizey+6;
	 };
       //restore the old background
       putimage(left,top,background,0);

       //set new coordinates
       left=xx;right=xx+sx;top=yy;bottom=yy+sy;

       //get new background
       getimage(left,top,right,bottom,background);

       //draw toolbar at new location
       draw();

	  //show the mouse
	  m.show();

	  };
	  };



void pbtoolbar::move(int deltax,int deltay)
{
int index;
left=left+deltax;
top=top+deltay;
right=right+deltax;
bottom=bottom+deltay;

 for (index=0; index < buttons; index++)
	{
	 tbutton[index]->left=tbutton[index]->left+deltax;
	 tbutton[index]->right=tbutton[index]->right+deltax;
	 tbutton[index]->top=top+3;
	 tbutton[index]->bottom=top+tbutton[index]->sizey+6;
	 };
};


///////////////////////////////////////////////////////////////////
pbtoolbar::~pbtoolbar(void)
{

int index;
for (index=0;index<buttons;index++)
 {
  if(tbutton[index]!=NULL)delete tbutton[index];
 };
 if(background!=NULL)delete background;
};
///////////////////////////////////////////////////////////////////

