//message constants
#define SC_DOWN 1300
#define SC_UP 1301
#define SC_SLIDER 1302
//mmt 606-633-3008

///////////////////////////////////////////////////////////////////
class scrollbar:public QOM
{
public:
int pixrange;
int pixposition;
int position;
int range;
float scaler;
int direction;
int pb1lft,pb2lft,pb1top,pb2top;
RECT slider;
//scrollbox *scroller;
pushbutton *negpb,*pospb,*sliderpb;
scrollbar(QOM  *OWNER,int lft,int tp,int w,int d,int dir,int rng,int Id);
void makertable();
void scrollup();
void scrolldown();
void scrollslider();
void increase_range(int delta);
void increase_position();
void  decrease_position();
void reposition();
virtual void rescale();
virtual void draw();
//virtual void move(int deltax,int deltay);
//virtual ~scrollbar();
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
scrollbar::scrollbar(QOM  *OWNER,
		     int lft,
		     int tp,
		     int w,
		     int d,
		     int dir,
		     int rng,
		     int Id):QOM(OWNER,lft,tp,w,d,id,PA_STATIC)
{
 direction =dir;
 range=rng;
 negpb->magnable=1;
 pospb->magnable=1;
 if (direction==0)
 {
  pixrange=sizex-39;
  scaler=float(float(pixrange)/float(range));
  position=0;
  pixposition=13+left+int (position*scaler);
  negpb=new pushbutton(owner,w+lft-13,tp,10,10,"c:\\bmp\\scright.bmp",SC_DOWN,PBS_NOBORDER);
  pospb=new pushbutton(owner,lft,tp,10,10,"c:\\bmp\\scleft.bmp",SC_UP,PBS_NOBORDER);
  sliderpb=new pushbutton(owner,lft+13,tp,10,10,"c:\\bmp\\grey.bmp",SC_SLIDER,PBS_NOBORDER);
  negpb->CC=new LAYOUT_METRICS();
  negpb->CC->X1->set(&right,-14);
  negpb->CC->Y1->set(&top,0);
  negpb->CC->X2->set(&negpb->left,negpb->sizex);
  negpb->CC->Y2->set(&negpb->top,negpb->sizey);
  pospb->CC=new LAYOUT_METRICS();
  pospb->CC->X1->set(&left,0);
  pospb->CC->Y1->set(&top,0);
  pospb->CC->X2->set(&pospb->left,pospb->sizex);
  pospb->CC->Y2->set(&pospb->top,pospb->sizey);
 };
 if (direction==1)
 {
  pixrange=sizey-39;
  scaler=float(float(pixrange)/float(range));
  position=0;
  pixposition=13+top+int (position*scaler);
  negpb=new pushbutton(owner,lft,d+tp-13,10,10,"c:\\bmp\\scdown.bmp",SC_DOWN,PBS_NOBORDER);
  pospb=new pushbutton(owner,lft,tp,10,10,"c:\\bmp\\scup.bmp",SC_UP,PBS_NOBORDER);
  sliderpb=new pushbutton(owner,lft,tp+13,10,10,"c:\\bmp\\grey.bmp",SC_SLIDER,PBS_NOBORDER);
  negpb->CC=new LAYOUT_METRICS();
  negpb->CC->X1->set(&left,0);
  negpb->CC->Y1->set(&bottom,-14);
  negpb->CC->X2->set(&negpb->left,negpb->sizex);
  negpb->CC->Y2->set(&negpb->top,negpb->sizey);
  pospb->CC=new LAYOUT_METRICS();
  pospb->CC->X1->set(&left,0);
  pospb->CC->Y1->set(&top,0);
  pospb->CC->X2->set(&pospb->left,pospb->sizex);
  pospb->CC->Y2->set(&pospb->top,pospb->sizey);
 };
makertable();
};
///////////////////////////////////////////////////////////////////
void scrollbar::rescale()
{
 if (direction==0)
 {
  pixrange=sizex-39;
  scaler=float(float(pixrange)/float(range));
  pixposition=13+left+int (position*scaler);
  sliderpb->move(pixposition-sliderpb->left,top-sliderpb->top);
 };

 if (direction==1)
 {
  pixrange=sizey-39;
  scaler=float(float(pixrange)/float(range));
  pixposition=13+top+int (position*scaler);
  sliderpb->move(left-sliderpb->left,pixposition-sliderpb->top);
 };
};


///////////////////////////////////////////////////////////////////
void scrollbar::increase_range(int delta)
{
 range=range+delta;
 scaler=float(float(pixrange)/float(range));
 pixposition=top+int (position*scaler);
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void scrollbar::makertable()
{
//DEFINE_NATURE(scrollbar,&negpb->pressedinportal,1,scrolldown);
//DEFINE_NATURE(scrollbar,&pospb->pressedinportal,1,scrollup);
//DEFINE_RESPONSE(scrollbar,SC_UP,scrollup);
//DEFINE_RESPONSE(scrollbar,SC_DOWN,scrolldown);
//DEFINE_RESPONSE(scrollbar,SC_SLIDER,scrollslider);
};
///////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////
void scrollbar::draw()
{

loweredbar(left,top,right,bottom,LightLightGrey);
negpb->show();
pospb->show();
sliderpb->show();
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
//void scrollbar::move(int deltax,int deltay)
//{
//portal::move(deltax,deltay);
//negpb->move(deltax,deltay);
//pospb->move(deltax,deltay);
//sliderpb->move(deltax,deltay);
//};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void scrollbar::scrollup()
{
if(position>0)
{
 m.read();
 if(m.l_button!=1)
   {
    pospb->pressedinportal=0;
    m.hide();
    pospb->pbup();
    m.show();
    return;
   };
  decrease_position();
 };
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void scrollbar::scrolldown()
{
if(position<range)
  {
   m.read();
   if(m.l_button!=1)
     {
      negpb->pressedinportal=0;
      m.hide();
      negpb->pbup();
      m.show();
      return;
      };
   increase_position();
  };
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void scrollbar::scrollslider()
{
 textbox(left+14,top,position);
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void scrollbar::increase_position()
{
 position=position+1;
 reposition();
};
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void scrollbar::decrease_position()
{
 position=position-1;
 reposition();
};
///////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////
void scrollbar::reposition()
{
if(direction==0)
   {
    setfillstyle(SOLID_FILL,LightLightGrey);
    bar(sliderpb->left,
	sliderpb->top+1,
	sliderpb->right,
	sliderpb->bottom-1);

	 pixposition=(left+13+(position*scaler));
    sliderpb->move(pixposition-sliderpb->left,0);
   };
 if(direction==1)
   {

    setfillstyle(SOLID_FILL,LightLightGrey);
    bar(sliderpb->left+1,
	sliderpb->top,
	sliderpb->right-1,
	sliderpb->bottom);
    pixposition=(top+13+(position*scaler));
    sliderpb->move(0,pixposition-sliderpb->top);
   };
    sliderpb->show();
};
////////////////////////////////////////////////////////////////////

//scrollbar::~scrollbar()
//{
//if(negpb!=NULL) delete negpb;
//if(pospb!=NULL) delete pospb;
//if(sliderpb!=NULL) delete sliderpb;
//if(scroller!=NULL)delete scroller;
//};