//The NODE and the WHEEL of NODES
//Written By Billy Stiltner COPYRIGHT 1996 Billy Stiltner
/*/
Copyright (C) 1995  Billy Stiltner

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; 

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
/*/
//#include<alloc.h>
//This is a very simple set of classes for a Node and List 
///////////////////////////////////////////////////////////////////
unsigned long nexusconstructors;
unsigned long roticonstructors;
unsigned long nexusdestructors;
unsigned long rotidestructors;
class NEXUS;
typedef void (NEXUS::*pMF)();
//typedef class *pC;

class NEXUS
{
public:
//data members
NEXUS *next;
NEXUS *previous;
//member functions
NEXUS();
NEXUS *GET_NEXT();
NEXUS *operator ++();
NEXUS *operator --();
//NEXUS *operator +(int n);
//NEXUS *operator -(int n);
int IS_PRIMUS();
int IS_MAXIMUS();
int IS_INTERNEXUS();
int IS_UNUSNEXUS();
virtual ~NEXUS();
};
///////////////////////////////////////////////////////////////////     .


///////////////////////////////////////////////////////////////////////////
class ROTI : public NEXUS
{
public:
 //data members
 NEXUS *PRIMUS;
 NEXUS *MAXIMUS;
 NEXUS *PROXIMUS;
 NEXUS *BUFF;
 //member functions
 ROTI();
 void PUT_PRIMUS(NEXUS *p);
 void PUT_MAXIMUS(NEXUS *p);
 void PUT_BEFORE_PROXIMUS(NEXUS *p);
 void PUT_AFTER_PROXIMUS(NEXUS *p);
 void PUT_BEFORE_NEXUS(NEXUS *p,NEXUS *q);
 void PUT_AFTER_NEXUS(NEXUS *p,NEXUS *q);
 void XFER(NEXUS *n,ROTI *r);
 void DELETE_NEXUS(NEXUS *p);
 void FOR_EACH(pMF pFunc);
 void EXTRACT_NEXUS(NEXUS *p);
virtual ~ROTI();
};
/////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////
NEXUS::NEXUS()
{
//nexusconstructors++;
next=NULL;
previous=NULL;
}
///////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
int NEXUS::IS_PRIMUS()
{
if((!previous)&&(next))
return(1);else return(0);
}
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
int NEXUS::IS_MAXIMUS()
{
if((!next)&&(previous))
return(1);else return(0);
}
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
int NEXUS::IS_INTERNEXUS()
{
if((previous)&&(next))
return(1);else return(0);
}
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
int NEXUS::IS_UNUSNEXUS()
{
if((!previous)&&(!next))
return(1);else return(0);
}
//////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////
NEXUS *NEXUS::GET_NEXT()
{ // NEXUS *j;
//j=this->next;
return(next);
}
///////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////
inline NEXUS *NEXUS::operator ++()
{ // NEXUS *j;
//j=this->next;
return(next);
}
///////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////
inline NEXUS *NEXUS::operator --()
{
return(previous);
}
///////////////////////////////////////////////////////////////////////////

/*///////////////////////////////////////////////////////////////////////////
inline NEXUS *NEXUS::operator +(int n)
{
 int c;
 NEXUS *np;
np=this;
if(np!=NULL)
{
 for(c=0;c<n;c++)
	 {
	  np=np->next;
	  if(np==NULL)break;
	  };
};
return(np);
};
///////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////
inline NEXUS *NEXUS::operator -(int n)
{
 int c;
 NEXUS *np;
np=this;
if(np!=NULL)
{
 for(c=0;c<n;c++)
	 {
	  np=np->previous;
	  if(np==NULL)break;
	  };
};
return(np);
};
//*/////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////
NEXUS::~NEXUS()
{
//nexusdestructors++;
//cout<<"IN NEXUS Destructor"<<"\n";
}
///////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
ROTI::ROTI():NEXUS()
{
//roticonstructors++;
 PRIMUS=NULL;
 MAXIMUS=NULL;
 PROXIMUS=NULL;
 BUFF=NULL;
}
///////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void ROTI::PUT_PRIMUS(NEXUS *p)
{
 p->next = PRIMUS;
 p->previous = NULL;
 if(!p->IS_UNUSNEXUS()){
 p->next->previous = p;
 }else{
		MAXIMUS = p;
		};
 PRIMUS = p;
}
////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////
void ROTI::PUT_MAXIMUS(NEXUS *p)
{
 p->previous = MAXIMUS;
 p->next = NULL;
 if(!p->IS_UNUSNEXUS()){
 p->previous->next = p;
 }else{
		PRIMUS = p;
		};
 MAXIMUS = p;
}
///////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void ROTI::PUT_BEFORE_PROXIMUS(NEXUS *p)
{
if(PROXIMUS!=NULL)PUT_BEFORE_NEXUS(p,PROXIMUS);
}
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void ROTI::PUT_AFTER_PROXIMUS(NEXUS *p)
{
if(PROXIMUS!=NULL)PUT_AFTER_NEXUS(p,PROXIMUS);
}
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void ROTI::PUT_BEFORE_NEXUS(NEXUS *p,NEXUS *q)
{
if(q)
  {
	if((q->IS_INTERNEXUS())||(q->IS_MAXIMUS()))
	  {
		p->next=q;
		p->previous=q->previous;
		q->previous->next=p;
		q->previous=p;
	  }else{
	  if(q->IS_PRIMUS())PUT_PRIMUS(p);
	  }
  }
}
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void ROTI::PUT_AFTER_NEXUS(NEXUS *p,NEXUS *q)
{
if(q)
  {
  if((q->IS_INTERNEXUS())||(q->IS_PRIMUS()))
	 {
	  p->previous=q;
	  p->next=q->next;
	  q->next->previous=p;
	  q->next=p;
	 }else{
	  if(q->IS_MAXIMUS())PUT_MAXIMUS(p);
	 }
  }
}
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
void ROTI::XFER(NEXUS *n,ROTI *r)
{
 //-+EXTRACT_NEXUS(n);
 r->PUT_MAXIMUS(n);
}
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
//REMOVES NEXUS FROM ROTI AND DELETES NEXUS
void ROTI::DELETE_NEXUS(NEXUS *p)
{
if((p->next)&&(p->previous)) //if p is between
{
 p->previous->next=p->next;//adjust previous
 p->next->previous=p->previous;//adjust next
 if(PROXIMUS==p)PROXIMUS=p->next; //if p was PROXIMUS make next PROXIMUS
 if(p!=NULL)delete p;//delete p
 return;
}
if(!p->next)
{
 MAXIMUS=p->previous;
 p->previous->next=NULL;
 if(PROXIMUS==p)
 {
 if(!p->previous){
	PROXIMUS=NULL;}else{PROXIMUS=p->previous;}
 }
	if(p)delete p;
	return;
}

if(!p->previous)
{
 PRIMUS=p->next;
 p->next->previous=NULL;
 if(!PROXIMUS)
 {
  if(!p->next){
		 PROXIMUS=NULL;}else{PROXIMUS=p->next;}
 }
	if(p)delete p;
 return;
}
//if(p->pPORTAL!=NULL)delete p->pPORTAL;
}
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
//EXTRACTS A NEXUS FROM LIST WITHOUT DELETING
void ROTI::EXTRACT_NEXUS(NEXUS *p)
{
 if(!p->previous){
	 PRIMUS=p->next;
	 p->next->previous=NULL;
	 }
 if(!p->next){
	 MAXIMUS=p->previous;
	 p->previous->next=NULL;
	 }
 if((p->next)&&(p->previous)){
 p->previous->next=p->next;
 p->next->previous=p->previous;
 }
}
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
void ROTI::FOR_EACH(pMF pFunc)
{
 if((PRIMUS)&&(MAXIMUS))//if not emptty
 for(NEXUS *current=PRIMUS;         //start on PRIMUS
	  current;                 //Stop after Maximus
	  current=++(*current))          //increment current
 (current->*pFunc)();               //call current function


}
///////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////
ROTI::~ROTI()
{
//rotidestructors++;
//cout<<"\n"<<"IN ROTI Destructor"<<"\n";
/*/
//roti can only be a base class and nexus can only be a base class
if(PRIMUS!=NULL)
 {
 NEXUS *NEXT;
  NEXUS* current = PRIMUS;
  for(;;)
	  {
	  NEXT=current->next;
		if(current!=NULL)delete current;
		if(current == NULL)break;
		current=NEXT;
	  };
  };
 /*/
}
///////////////////////////////////////////////////////////////////

